// Fragment shader for the bloom effect

#version 150

in vec2 quadTexCoords;

uniform sampler2D texColor;
uniform sampler2D texThresh;

uniform bool horizontal;
uniform bool threshold;

uniform float width;
uniform float height;

out vec4 out_Color;

void main(void)
{
	if(threshold)
	{
		vec4 col = texture2D(texColor, quadTexCoords);

		float grayScale = 0.2989*col.r+0.5870*col.g+0.1140*col.b;

		//if(col.r > 0.6 && col.g > 0.6 && col.b > 0.6)
		if(grayScale > 0.6)
		{
			out_Color = col;
		}

	}else{
		if(horizontal)
		{

			vec4 col = texture2D(texThresh, quadTexCoords)*70;
		
			col += texture2D(texThresh, quadTexCoords+vec2(-4.0f/width,0.0));
			col += texture2D(texThresh, quadTexCoords+vec2(-3.0f/width,0.0))*8;
			col += texture2D(texThresh, quadTexCoords+vec2(-2.0f/width,0.0))*28;
			col += texture2D(texThresh, quadTexCoords+vec2(-1.0f/width,0.0))*56;
			col += texture2D(texThresh, quadTexCoords+vec2(1.0f/width, 0.0))*56;
			col += texture2D(texThresh, quadTexCoords+vec2(2.0f/width, 0.0))*28;
			col += texture2D(texThresh, quadTexCoords+vec2(3.0f/width,0.0))*8;
			col += texture2D(texThresh, quadTexCoords+vec2(4.0f/width,0.0));

			col /= 256;

			out_Color = col;
		}else{

			vec4 col = texture2D(texThresh, quadTexCoords)*70;
			
			col += texture2D(texThresh, quadTexCoords+vec2(0.0, -4.0f/height));
			col += texture2D(texThresh, quadTexCoords+vec2(0.0, -3.0f/height))*8;
			col += texture2D(texThresh, quadTexCoords+vec2(0.0, -2.0f/height))*28;
			col += texture2D(texThresh, quadTexCoords+vec2(0.0, -1.0f/height))*56;
			col += texture2D(texThresh, quadTexCoords+vec2(0.0, 1.0f/height))*56;
			col += texture2D(texThresh, quadTexCoords+vec2(0.0, 2.0f/height))*28;
			col += texture2D(texThresh, quadTexCoords+vec2(0.0, 3.0f/height))*8;
			col += texture2D(texThresh, quadTexCoords+vec2(0.0, 4.0f/height));

			col /= 256;

			vec4 col2 = texture2D(texColor, quadTexCoords);


			out_Color = col+col2;
		}
	}
}