// Fragment shader for the fullscreen quad without any effects

#version 150

in vec2 quadTexCoords;

uniform sampler2D texColor;
uniform float offset;

out vec4 out_Color;

void main(void)
{
		float r = texture2D(texColor, quadTexCoords).r;
		float g = texture2D(texColor, quadTexCoords).g;
		float b = texture2D(texColor, quadTexCoords).b;

		if(quadTexCoords.x+offset<=1.0f && quadTexCoords.x+offset>=0.0f)
		{
			g = texture2D(texColor, quadTexCoords+vec2(offset,0.0f)).g;
		}
		
		if(quadTexCoords.x+2*offset<=1.0f && quadTexCoords.x+2*offset>=0.0f)
		{
			b = texture2D(texColor, quadTexCoords+vec2(2*offset,0.0f)).b;
		}
		out_Color = vec4(r,g,b,1.0);
}